using System;
using System.Drawing;
using System.Windows.Forms;
using System.Runtime.InteropServices ;

namespace CSharpIDASample
{
	/// <summary>
	/// Description of Form1.
	/// </summary>
	public class Form1 : System.Windows.Forms.Form
	{
		private System.Windows.Forms.Label label1;
		private System.Windows.Forms.ColumnHeader Start;
		private System.Windows.Forms.ListView lv;
		private System.Windows.Forms.ColumnHeader n;
		private System.Windows.Forms.ColumnHeader End;
		
		[DllImport("c_stub.plw")]
		public static extern int NumFuncs();
		
		[DllImport("c_stub.plw")]
		public static extern int FunctionStart(int index);
		
		[DllImport("c_stub.plw")]
		public static extern int  FunctionEnd(int index); 
	
		public Form1()
		{
			//
			// The InitializeComponent() call is required for Windows Forms designer support.
			//
			InitializeComponent();
			
			//
			// TODO: Add constructor code after the InitializeComponent() call.
			//
		}
		
		#region Windows Forms Designer generated code
		/// <summary>
		/// This method is required for Windows Forms designer support.
		/// Do not change the method contents inside the source code editor. The Forms designer might
		/// not be able to load this method if it was changed manually.
		/// </summary>
		private void InitializeComponent() {
			this.End = new System.Windows.Forms.ColumnHeader();
			this.n = new System.Windows.Forms.ColumnHeader();
			this.lv = new System.Windows.Forms.ListView();
			this.Start = new System.Windows.Forms.ColumnHeader();
			this.label1 = new System.Windows.Forms.Label();
			this.SuspendLayout();
			// 
			// End
			// 
			this.End.Width = 120;
			// 
			// lv
			// 
			this.lv.Columns.AddRange(new System.Windows.Forms.ColumnHeader[] {
						this.n,
						this.Start,
						this.End});
			this.lv.FullRowSelect = true;
			this.lv.GridLines = true;
			this.lv.HeaderStyle = System.Windows.Forms.ColumnHeaderStyle.Nonclickable;
			this.lv.Location = new System.Drawing.Point(8, 32);
			this.lv.Name = "lv";
			this.lv.Size = new System.Drawing.Size(304, 160);
			this.lv.TabIndex = 1;
			this.lv.View = System.Windows.Forms.View.Details;
			// 
			// Start
			// 
			this.Start.Width = 120;
			// 
			// label1
			// 
			this.label1.Location = new System.Drawing.Point(8, 8);
			this.label1.Name = "label1";
			this.label1.Size = new System.Drawing.Size(160, 16);
			this.label1.TabIndex = 0;
			this.label1.Text = "Num Functions = ";
			// 
			// Form1
			// 
			this.AutoScaleBaseSize = new System.Drawing.Size(5, 14);
			this.ClientSize = new System.Drawing.Size(320, 197);
			this.Controls.Add(this.lv);
			this.Controls.Add(this.label1);
			this.MaximizeBox = false;
			this.MinimizeBox = false;
			this.Name = "Form1";
			this.StartPosition = System.Windows.Forms.FormStartPosition.CenterScreen;
			this.Text = "C# OllyDbg Plugin Sample";
			this.Load += new System.EventHandler(this.Form1Load);
			this.ResumeLayout(false);
		}
		#endregion
		void Form1Load(object sender, System.EventArgs e)
		{
			
			int n, startEA, endEA;
			ListViewItem li;
			
			n = NumFuncs();
			label1.Text += n;
				
			for(int i=0 ; i<n ; i++){
				
				startEA = FunctionStart(i);
		    	endEA = FunctionEnd(i);
				
		    	li = lv.Items.Add( i.ToString() );
		    	li.SubItems.Add( startEA.ToString("X") )  ;
		    	li.SubItems.Add( endEA.ToString("X")   ) ;
		    	
		    	
			}
 			
			
		}
		
	}
}
